---
title: Color contrast
slug: Web/Accessibility/Understanding_WCAG/Perceivable/Color_contrast
tags:
  - Accessibility
  - WCAG
  - contrast
  - perceivable
---
<p>The <a href="https://www.w3.org/TR/WCAG21/#dfn-contrast-ratio">color contrast</a> between background and foreground content (that is, usually text) should be great enough to ensure legibility.</p>

<p>When designing readable interfaces for different vision capabilities, the WCAG guidelines recommend the following contrast ratios:</p>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Type of content</th>
   <th scope="col">Minimum ratio (AA rating)</th>
   <th scope="col">Enhanced ratio (AAA rating)</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>Body text</td>
   <td>4.5 : 1</td>
   <td>7 : 1</td>
  </tr>
  <tr>
   <td>Large-scale text (120-150% larger than body text)</td>
   <td>3 : 1</td>
   <td>4.5 : 1</td>
  </tr>
  <tr>
   <td>Active user interface components and graphical objects such as icons and graphs</td>
   <td>3 : 1</td>
   <td>Not defined</td>
  </tr>
 </tbody>
</table>

<p>These ratios do not apply to "incidental" text, such as inactive controls, logotypes, or purely decorative text.</p>

<p>See the {{anch("Solution")}} section below for further information.</p>

<p>Having good color contrast on your site benefits all your users, but it is particularly beneficial to users with certain types of color blindness and other similar conditions, who experience low contrast, and have trouble differentiating between similar colors. This is because they don't see bright and dark areas as readily as those without such conditions, and therefore have trouble seeing edges, borders, and other details.</p>

<p>It is good to have a cool design on your website, but the design is worthless if your users can't read your content.</p>

<h2 id="Examples">Examples</h2>

<p>Let's have a look at some simple HTML and CSS code:</p>

<pre class="brush: html">&lt;div class="good"&gt;Good contrast&lt;/div&gt;
&lt;div class="bad"&gt;Bad contrast&lt;/div&gt;</pre>

<pre class="brush: css">div {
  /* General div styles here */
}

.good {
  background-color: #fae6fa;
}

.bad {
  background-color: #400064;
}</pre>

<p>Both pieces of text have their default black color. The "good" <code>&lt;div&gt;</code> has a light purple background, which makes the text easy to read:</p>

<div class="hidden">
<h4 id="example1">example1</h4>

<pre class="brush: html">    &lt;div class="good"&gt;
      Good contrast
    &lt;/div&gt;</pre>

<pre class="brush: css">div {
  font-family: sans-serif;
  text-align: center;
  font-size: 2rem;
  font-weight: bold;
  width: 250px;
  padding: 30px;
  border-radius: 20px;
  box-shadow: 1px 1px 1px black;
}

.good {
  background-color: #fae6fa;
}</pre>
</div>

<p>{{EmbedLiveSample('example1', '100%', '100')}}</p>

<p>The "bad" <code>&lt;div&gt;</code> on the other hand has a very dark purple background, which makes the text much harder to read:</p>

<div class="hidden">
<h4 id="example2">example2</h4>

<pre class="brush: html">    &lt;div class="bad"&gt;
      Bad contrast
    &lt;/div&gt;</pre>

<pre class="brush: css">div {
  font-family: sans-serif;
  text-align: center;
  font-size: 2rem;
  font-weight: bold;
  width: 250px;
  padding: 30px;
  border-radius: 20px;
  box-shadow: 1px 1px 1px black;
}

.bad {
  background-color: #400064;
}</pre>
</div>

<p>{{EmbedLiveSample('example2', '100%', '100')}}</p>

<h2 id="Solution">Solution</h2>

<p>When choosing a color scheme for your website, choose foreground and background colors that have good contrast. Make the color contrast as good as it can be within your design constraints — ideally go for the AAA rating (see 1.4.6 below), but at least meet the AA rating (see 1.4.3 below).</p>

<p>If you are including non-text content such as video or animation, you should follow 1.4.11 (again, see below).</p>

<p>To check your contrast as you make your color choices, use a tool such as WebAIM's <a class="external external-icon" href="http://webaim.org/resources/contrastchecker/" rel="noopener">Color Contrast Checker</a>.</p>

<p>You can also check color contrast on the fly using Firefox's Developer Tools — see our <a href="/en-US/docs/Tools/Accessibility_inspector">Accessibility inspector</a> guide, and in particular the section <a href="/en-US/docs/Tools/Accessibility_inspector#Check_for_accessibility_issues">Check for accessibility issues</a>. Try using it on the live examples in the description section.</p>

<h2 id="Related_WCAG_success_criteria">Related WCAG success criteria</h2>

<dl>
 <dt><a href="https://www.w3.org/TR/WCAG21/#contrast-minimum">1.4.3 Minimum contrast (AA)</a></dt>
 <dd>The color contrast between background and foreground content should be at a minimum level to ensure legibility:
 <ul>
  <li>Text and its background should have a contrast ratio of at least 4.5:1.</li>
  <li>Heading (or just larger) text should have a ratio of at least 3:1. Larger text is defined as at least 18pt, or 14pt bold.</li>
 </ul>
 </dd>
 <dt><a href="https://www.w3.org/TR/WCAG21/#contrast-enhanced">1.4.6 Enhanced contrast (AAA)</a></dt>
 <dd>This follows, and builds on, criterion 1.4.3.
 <ul>
  <li>Text and its background should have a contrast ratio of at least 7:1.</li>
  <li>Heading (or just larger) text should have a ratio of at least 4.5:1.</li>
 </ul>
 </dd>
 <dt><a href="https://www.w3.org/TR/WCAG21/#non-text-contrast">1.4.11 Non-Text Contrast (AA)</a> (added in 2.1)</dt>
 <dd>There should be a minimum color contrast ratio of 3 to 1 for user interface components and graphical objects.</dd>
</dl>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Learn/Accessibility/CSS_and_JavaScript#Color_and_color_contrast">Color and color contrast</a></li>
 <li><a href="/en-US/docs/Learn/HTML/Forms/How_to_structure_an_HTML_form#Multiple_labels">Multiple labels</a></li>
 <li><a href="https://www.w3.org/WAI/WCAG21/Understanding/non-text-contrast.html">Understanding Non-Text Contrast</a></li>
</ul>
